Unit SetAlarm;
interface
uses Objects, Dos, Crt, Drivers, Views, Menus, Dialogs, App,Check;

type
    DialogData = record
    InputLineHour: string[5];
    InputLineMinute: string[5];
end;
	PDemoDialog = ^TDemoDialog;
	TDemoDialog = object(TDialog)
	procedure HandleEvent(var Event:TEvent); virtual;
        end;

  TMyApp = object(TApplication)
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure InitMenuBar; virtual;
    procedure NewDialog;
    procedure SetAlarmClock;
    procedure NewMessageDialog;
	procedure ErrorMessageDialog;
  end;


	var
	DemoDialogData: DialogData;
	Dialog: PDemoDialog;
	Dialog2:PDemoDialog;

implementation

  const cmNewDialog       = 102;
  cmBut =103;
  cmSAlCl = 104;
  cmAlMessage = 105;

procedure TMyApp.HandleEvent(var Event: TEvent);
begin
  TApplication.HandleEvent(Event);
  if Event.What = evCommand then
  begin
    case Event.Command of
      cmNewDialog: NewDialog;
      cmSAlCl: SetAlarmClock;
      cmAlMessage:NewMessageDialog;
    else
      Exit;
    end;
    ClearEvent(Event);
  end;
end;

procedure TDemoDialog.HandleEvent(var Event: TEvent);
begin

TDialog.HandleEvent(Event);

if Event.What = evCommand then
  begin
    case Event.Command of
      cmBut:
      begin
       Event.Command:=cmSAlCl;
       Owner^.Owner^.HandleEvent(Event);
      end
  else Exit;
    end;
  ClearEvent(Event);
  end;
end;

procedure TMyApp.SetAlarmClock;
 var
  h,m,Hcur,Mcur,Scur,SScur:word;
  Event: TEvent;
begin
   Dialog^.GetData(DemoDialogData);
   	if (Bool_f(DemoDialogData.InputLineHour,DemoDialogData.InputLineMinute)= true)  then
	begin
		val(DemoDialogData.InputLineHour,h);
		val(DemoDialogData.InputLineMinute,m);

			if (h <= 23) and ( m <= 59) then
			   begin
					repeat
						 GetTime(Hcur,Mcur,Scur,SScur);
					until (h=Hcur) and (m=Mcur);
					NewMessageDialog;

				end;
	end
	else
		ErrorMessageDialog;

end;

procedure TMyApp.NewMessageDialog;
var
  Bruce: PView;
  R: TRect;
  C: Word;
begin
  R.Assign(0, 0, 40,20);
  Dialog2 := New(PDemoDialog, Init(R, 'ALARM'));
  with Dialog2^ do
  begin
  R.Assign(9, 9, 30, 10);
  Insert(New(PLabel, Init(R, 'Time is ~over~!!!', Bruce)));
   Sound(500);
   end;
   C := DeskTop^.ExecView(Dialog2);
   Sound(0);
  Dispose(Dialog2, Done);
end;

procedure TMyApp.ErrorMessageDialog;
var
  Bruce: PView;
  R: TRect;
  C: Word;
begin
  R.Assign(0, 0, 70,20);
  Dialog2 := New(PDemoDialog, Init(R, 'ERROR'));
  with Dialog2^ do
  begin
  R.Assign(9, 9, 70, 10);
  Insert(New(PLabel, Init(R, 'ERROR! YOUR INPUT MUST INCLUDE ONLY NUMBERS! TRY AGAIN.', Bruce)));
   end;
   C := DeskTop^.ExecView(Dialog2);
  Dispose(Dialog2, Done);
end;



procedure TMyApp.InitMenuBar;
var R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~W~indow', hcNoContext, NewMenu(
      NewItem('~A~larm', 'F2', kbF2, cmNewDialog, hcNoContext,
      nil)),
    nil)
  )));
end;



procedure TMyApp.NewDialog;
var
  Bruce: PView;
  R: TRect;
  C: Word;
begin
  R.Assign(0, 0, 60, 20);
  Dialog := New(PDemoDialog, Init(R, 'SET ALARM'));
  with Dialog^ do
  begin
    R.Assign(11,2, 58, 3);
    Bruce := New(PInputLine, Init(R,5));
    Insert(Bruce);

    R.Assign(2, 2, 8, 3);
    Insert(New(PLabel, Init(R, 'Hours', Bruce)));

    R.Assign(11,5,58, 6 );
    Bruce := New(PInputLine, Init(R,5));
    Insert(Bruce);

    R.Assign(2, 5,10 , 6);
    Insert(New(PLabel, Init(R, 'Minutes', Bruce)));

    R.Assign(15, 10, 25, 12);
    Insert(New(PButton, Init(R, '~O~k', cmBut, bfDefault)));
	
	R.Assign(28, 10, 38, 12);
    Insert(New(PButton, Init(R, 'Cancel', cmCancel, bfNormal)));

  end;
        Dialog^.SetData(DemoDialogData);
        C := DeskTop^.ExecView(Dialog);
  Dispose(Dialog, Done);
end;

end .
